#!/bin/bash 

touch /tmp/startvnc.1

USER=$1
DESKTOP=`id -u $1`
USERID=$DESKTOP
GROUPID=`id -g $1`

CFGPATH=/home/controls/sbin

touch /tmp/startvnc.2

#Check if the nvc directory exists if no make it with a bubez passwd file 
if [ ! -d /home/$USER/.vnc ]
then
  sudo mkdir /home/$USER/.vnc
fi

if [ ! -f /home/$USER/.vnc/passwd ]
then
  sudo cp ${CFGPATH}/vncpasswd /home/$USER/.vnc/passwd
  sudo chown -R $USERID:$GROUPID /home/$USER/.vnc/
  sudo chmod 600 /home/$USER/.vnc/passwd
  # Control will enter here if $DIRECTORY doesn't exist
fi

sudo cp ${CFGPATH}/xstarttemplate.sh /home/$USER/.vnc/xstartup
sudo chown -R $USERID:$GROUPID /home/$USER/.vnc/xstartup

sudo echo "startx -- :"${DESKTOP}  >> /home/$USER/.vnc/xstartup
sudo chmod a+x  /home/$USER/.vnc/xstartup

if [ -f /home/$USER/.vnc/resolution.dat ]
  then
    export RESOLUTION=`cat /home/$USER/.vnc/resolution.dat`
  else
    export RESOLUTION=1280x1024
fi

sudo -i -u ${USER} vncserver :${DESKTOP} -name ${USER} -securitytypes=none -geometry ${RESOLUTION} >& /tmp/startvnc.log

touch /tmp/startvnc.3

VNCPORT=$((${USERID}+5900))
echo ${VNCPORT}

date >> /var/log/vcr/${USER}.log

exit 0

# EOF
