//=============================================================================
//
// file :        ScriptRunner.h
//
// description : Include for the ScriptRunner class.
//
// project :	ScriptRunner
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _SCRIPTRUNNER_H
#define _SCRIPTRUNNER_H



#include <tango.h>
#include <list>
#include <set>

//using namespace Tango;

/**
 * @author	$Author:  $
 * @version	$Revision:  $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------

class BotanUtils;

namespace ScriptRunner_ns
{

/**
 * Class Description:
 * Runs scripts on local host
 */

/*
 *	Device States Description:
*  Tango::ON :
*  Tango::FAULT :
*  Tango::RUNNING :
 */


class ScriptRunner: public TANGO_BASE_CLASS
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevString	*attr_Output_read;
		Tango::DevString	*attr_Error_read;
		Tango::DevLong	*attr_ExitStatus_read;
		Tango::DevString	*attr_ScriptsRepositoryPath_read;
		Tango::DevString	attr_ScriptsRepositoryPath_write;
		Tango::DevString	*attr_CommandLineParams_read;
		Tango::DevString	attr_CommandLineParams_write;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	
 */
	string	defaultScriptsRepositoryPath;
/**
 *	
 */
	Tango::DevBoolean	encryption;
/**
 *	
 */
	string	devicePrivateKeyFile;
/**
 *	
 */
	string	devicePrivateKeyPassphraseFile;
/**
 *	
 */
	string	clientPublicKeyFile;
/**
 *	
 */
	string	allowedIPFile;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	ScriptRunner(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	ScriptRunner(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	ScriptRunner(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~ScriptRunner() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name ScriptRunner methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for Output acquisition result.
 */
	virtual void read_Output(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Error acquisition result.
 */
	virtual void read_Error(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ExitStatus acquisition result.
 */
	virtual void read_ExitStatus(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ScriptsRepositoryPath acquisition result.
 */
	virtual void read_ScriptsRepositoryPath(Tango::Attribute &attr);
/**
 *	Write ScriptsRepositoryPath attribute values to hardware.
 */
	virtual void write_ScriptsRepositoryPath(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for CommandLineParams acquisition result.
 */
	virtual void read_CommandLineParams(Tango::Attribute &attr);
/**
 *	Write CommandLineParams attribute values to hardware.
 */
	virtual void write_CommandLineParams(Tango::WAttribute &attr);
/**
 *	Read/Write allowed for Output attribute.
 */
	virtual bool is_Output_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Error attribute.
 */
	virtual bool is_Error_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ExitStatus attribute.
 */
	virtual bool is_ExitStatus_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ScriptsRepositoryPath attribute.
 */
	virtual bool is_ScriptsRepositoryPath_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CommandLineParams attribute.
 */
	virtual bool is_CommandLineParams_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for RunScript command.
 */
	virtual bool is_RunScript_allowed(const CORBA::Any &any);
/**
 * 
 *	@param	argin	
 *	@exception DevFailed
 */
	void	run_script(Tango::DevString);

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	
	
	//BotanUtils *botan_utils;
	
	struct thread_params
	{
		ScriptRunner * obj;
		string script;
		list<string> params;
	};
	
	
	// synchronization
	
	// state & status
	virtual Tango::DevState state(); // override state command to add synchronization
	virtual char * status(); // override status command to add synchronization
	Tango::DevState safe_get_state();
	string safe_get_status();
	void safe_set_state_status(const Tango::DevState & new_state, const string & new_status);
	pthread_mutex_t output_values_mutex;
	pthread_mutex_t state_mutex;
	
	// thread
	
	pthread_t thread;
	volatile bool thread_valid;
	static void *thread_trampoline (void *param);
	void run_script_thread(thread_params * tp);

	// attributes
	
	string output;
	Tango::DevString output_s;
	
	string error;
	Tango::DevString error_s;
	
	string scriptsRepositoryPath;
	Tango::DevString scriptsRepositoryPath_s;
	
	list<string> commandLineParams;
	Tango::DevString commandLineParams_s;
	
	Tango::DevLong exitStatus;
	
	std::string eventually_encrypt_with_im_public_key(const std::string & in);
	bool eventually_decrypt_with_device_private_key(const std::string & in, std::string & clear);
	
	bool access_control_on;
	std::set<std::string> allowed_ips;
	void get_ips_from_host(const std::string & node, std::set<std::string> & ips);
};

}	// namespace_ns

#endif	// _SCRIPTRUNNER_H
