//=============================================================================
//
// file :         ScriptRunnerClass.h
//
// description :  Include for the ScriptRunnerClass root class.
//                This class is represents the singleton class for
//                the ScriptRunner device class.
//                It contains all properties and methods which the 
//                ScriptRunner requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _SCRIPTRUNNERCLASS_H
#define _SCRIPTRUNNERCLASS_H

#include <tango.h>
#include <ScriptRunner.h>


namespace ScriptRunner_ns
{//=====================================
//	Define classes for attributes
//=====================================
class CommandLineParamsAttrib: public Tango::SpectrumAttr
{
public:
	CommandLineParamsAttrib():SpectrumAttr("CommandLineParams", Tango::DEV_STRING, Tango::READ_WRITE, 32) {};
	~CommandLineParamsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ScriptRunner *>(dev))->read_CommandLineParams(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<ScriptRunner *>(dev))->write_CommandLineParams(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ScriptRunner *>(dev))->is_CommandLineParams_allowed(ty);}
};

class ScriptsRepositoryPathAttrib: public Tango::Attr
{
public:
	ScriptsRepositoryPathAttrib():Attr("ScriptsRepositoryPath", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~ScriptsRepositoryPathAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ScriptRunner *>(dev))->read_ScriptsRepositoryPath(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<ScriptRunner *>(dev))->write_ScriptsRepositoryPath(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ScriptRunner *>(dev))->is_ScriptsRepositoryPath_allowed(ty);}
};

class ExitStatusAttrib: public Tango::Attr
{
public:
	ExitStatusAttrib():Attr("ExitStatus", Tango::DEV_LONG, Tango::READ) {};
	~ExitStatusAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ScriptRunner *>(dev))->read_ExitStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ScriptRunner *>(dev))->is_ExitStatus_allowed(ty);}
};

class ErrorAttrib: public Tango::Attr
{
public:
	ErrorAttrib():Attr("Error", Tango::DEV_STRING, Tango::READ) {};
	~ErrorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ScriptRunner *>(dev))->read_Error(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ScriptRunner *>(dev))->is_Error_allowed(ty);}
};

class OutputAttrib: public Tango::Attr
{
public:
	OutputAttrib():Attr("Output", Tango::DEV_STRING, Tango::READ) {};
	~OutputAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ScriptRunner *>(dev))->read_Output(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ScriptRunner *>(dev))->is_Output_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class RunScriptClass : public Tango::Command
{
public:
	RunScriptClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RunScriptClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RunScriptClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<ScriptRunner *>(dev))->is_RunScript_allowed(any);}
};



//
// The ScriptRunnerClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	ScriptRunnerClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static ScriptRunnerClass *init(const char *);
	static ScriptRunnerClass *instance();
	~ScriptRunnerClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	ScriptRunnerClass(string &);
	static ScriptRunnerClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace ScriptRunner_ns

#endif // _SCRIPTRUNNERCLASS_H
